> For the complete documentation index, see [llms.txt](https://docs.intrepidcs.com/vspy-3-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.intrepidcs.com/vspy-3-documentation/vehicle-spy-main-menus/main-menu-spy-networks/messages-view/messages-view-filter-bar/messages-view-custom-filters.md).

# Messages View Custom Filters

### Overview

Custom filters are filters than can include user defined groups of Messages, ECUs, and [Networks](/vspy-3-documentation/vehicle-spy-main-menus/main-menu-spy-networks/networks.md). This group can then be included or excluded in the [Filter Bar](/vspy-3-documentation/vehicle-spy-main-menus/main-menu-spy-networks/messages-view/messages-view-filter-bar.md). [Messages view](/vspy-3-documentation/vehicle-spy-main-menus/main-menu-spy-networks/messages-view.md) supports up to 99 custom filters.

### Details

Custom filters are located under the Messages category in the Filter Bar. By default, they are named Custom 1, Custom 2, and so on. Additional custom filters added by clicking the **Add** button at the top of the Filter Bar. To delete a custom filter, right click on it and select **Remove Message Filter**.

As with the other standard filters, clicking in the first column to the right of the filter name activates the filter (![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/chkFilter.gif)). Clicking in the second column to the right reverses the filter (![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/xFilter.gif)).

Edit the filter by clicking the small gray box in the third column to the right of the custom filter title (Figure 1:![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smOne.gif)). Clicking the box opens the Setup Filter dialog shown in **Figure 1**.

In the Setup Filter dialog, give the filter a custom name by typing in the **Name of Filter field** (Figure 1:![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smFive.gif)). The name entered replaces the default name in the Filter Bar when returning to Messages view. Renaming a filter is especially useful when working with several filters.

Next, define the filter. The first step is to select a data source located just below the Name of Filter heading (Figure 1:![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smTwo.gif)). They include: Rx Messages, Database, Tx Messages, Networks, ECUs, and Misc. Details about each data source can be found below in **Table 1**. When selecting a data source from the list, available items (messages, signals, etc.) will be shown in the central window in a tree (Figure 1:![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smThree.gif)).

To add an item to your filter, simply select it from the tree and press the **Add to Included List** button (Figure 1:![](https://cdn.intrepidcs.net/support/VehicleSpy/assets/smFour.gif)) or the **Add to Excluded List** button. A filter can contain both included and excluded items. (Double clicking on an item in the tree will automatically add it to the Included Items list.) All items added to a filter will appear in either the Included Items or Excluded Items list. If an item is accidentally added, remove it by selecting the item and pressing the **Remove** button. Clear the entire filter by pressing the **Clear** button.

When the filter is finished, press the **OK** button to automatically return to the Messages view. All that is left is to click in the green checkmark column and activate the filter!

![Figure 1: Building a Custom Filter for the Messages view.](/files/p31AAi9xTS2GCU5Isc8s)

**Table 1: Custom Filter Data Sources**

| Data Source                        | Description                                                                                                                                                                                                                                                                   |
| ---------------------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Rx Messages, Database, Tx Messages | A list of all messages and signals defined for each network in the [Messages Editor](/vspy-3-documentation/vehicle-spy-main-menus/main-menu-spy-networks/message-editor.md) or [Database](/vspy-3-documentation/vehicle-spy-main-menus/main-menu-setup/network-databases.md). |
| Networks                           | A list of [Networks](/vspy-3-documentation/vehicle-spy-main-menus/main-menu-spy-networks/networks.md).                                                                                                                                                                        |
| ECUs                               | A list of [ECUs](/vspy-3-documentation/vehicle-spy-main-menus/main-menu-setup/ecus-view.md) in each network.                                                                                                                                                                  |
| Misc                               | List of Message properties includes:                                                                                                                                                                                                                                          |
| Name                               | Description                                                                                                                                                                                                                                                                   |
| Network                            | Any network message.                                                                                                                                                                                                                                                          |
| Errors                             | Any message that has an error.                                                                                                                                                                                                                                                |
| Transmit                           | Any transmit Message.                                                                                                                                                                                                                                                         |
| Any Change                         | Any message with data that has changed.                                                                                                                                                                                                                                       |
| Length Mismatch                    | Any message with length mismatch.                                                                                                                                                                                                                                             |
| No Change                          | Any message with data that has not changed.                                                                                                                                                                                                                                   |
| No Match                           | Any message which wasn't identified.                                                                                                                                                                                                                                          |

| Name            | Description                                 |
| --------------- | ------------------------------------------- |
| Network         | Any network message.                        |
| Errors          | Any message that has an error.              |
| Transmit        | Any transmit Message.                       |
| Any Change      | Any message with data that has changed.     |
| Length Mismatch | Any message with length mismatch.           |
| No Change       | Any message with data that has not changed. |
| No Match        | Any message which wasn't identified.        |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.intrepidcs.com/vspy-3-documentation/vehicle-spy-main-menus/main-menu-spy-networks/messages-view/messages-view-filter-bar/messages-view-custom-filters.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
